> ## Documentation Index
> Fetch the complete documentation index at: https://docs.getprimo.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a custom field

> Create a new custom field definition. Labels are not constrained to be unique. Options are only allowed for SELECT and MULTI_SELECT field types.

<span className="badge-write">Key: Write</span><span className="badge-company">Scope: Company</span>


## OpenAPI

````yaml https://api.getprimo.com/openapi.json post /custom-fields
openapi: 3.1.1
info:
  title: Public API - BETA
  description: Read docs on https://docs.getprimo.com/
  version: '1.0'
  contact: {}
servers:
  - url: https://api.getprimo.com
security:
  - apikey: []
tags: []
paths:
  /custom-fields:
    post:
      tags:
        - CustomFields
      summary: Create a custom field
      description: >-
        Create a new custom field definition. Labels are not constrained to be
        unique. Options are only allowed for SELECT and MULTI_SELECT field
        types.
      operationId: createCustomField
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateCustomFieldBody'
      responses:
        '201':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CustomFieldResponse_Output'
components:
  schemas:
    CreateCustomFieldBody:
      type: object
      properties:
        label:
          description: Display label of the custom field. Not required to be unique.
          type: string
          minLength: 1
          maxLength: 120
        fieldType:
          description: Type of data this field holds.
          type: string
          enum:
            - SELECT
            - MULTI_SELECT
            - CHECKBOX
            - TEXT
            - DATE
            - NUMBER
            - URL
        applyTo:
          description: >-
            Entity types this field applies to. One or more of DEVICE,
            ACCESSORY, EMPLOYEE, ORDER.
          minItems: 1
          type: array
          items:
            type: string
            enum:
              - DEVICE
              - ACCESSORY
              - EMPLOYEE
              - ORDER
        options:
          description: >-
            Option catalog. Only allowed (and required) for SELECT and
            MULTI_SELECT field types.
          type: array
          items:
            type: object
            properties:
              value:
                type: string
                minLength: 1
                maxLength: 120
            required:
              - value
      required:
        - label
        - fieldType
        - applyTo
    CustomFieldResponse_Output:
      type: object
      properties:
        id:
          type: string
        companyId:
          type: string
        label:
          type: string
        fieldType:
          type: string
          enum:
            - SELECT
            - MULTI_SELECT
            - CHECKBOX
            - TEXT
            - DATE
            - NUMBER
            - URL
        applyTo:
          type: array
          items:
            type: string
            enum:
              - DEVICE
              - ACCESSORY
              - EMPLOYEE
              - ORDER
        status:
          type: string
          enum:
            - ACTIVE
            - ARCHIVED
        options:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                format: uuid
                pattern: >-
                  ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
              value:
                type: string
            required:
              - id
              - value
            additionalProperties: false
        createdAt:
          type: string
          format: date-time
          pattern: >-
            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
        updatedAt:
          type: string
          format: date-time
          pattern: >-
            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
      required:
        - id
        - companyId
        - label
        - fieldType
        - applyTo
        - status
        - options
        - createdAt
        - updatedAt
      additionalProperties: false
  securitySchemes:
    apikey:
      scheme: bearer
      bearerFormat: API key
      type: http
      description: >-
        Use your Primo API key in the Authorization header as `Bearer
        <API_KEY>`.

````